/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


// Main header file
#include <ToolBox\Headers.h>


// --- Class PointeredList ---

PointeredList::PointeredList()
{
	#ifdef _TOOLBOX_TEST
		InstanceCount++;
	#endif
}

PointeredList::~PointeredList()
{
	ASSERTION_THIS;

	#ifdef _TOOLBOX_TEST
		InstanceCount--;
	#endif
}

int PointeredList::CaseInsensitiveStringCompare(const PointeredListItem * Item1,
	const PointeredListItem * Item2)
{
	return stricmp((const char *) Item1->GetData(), (const char *) Item2->GetData());
}

int PointeredList::CaseSensitiveStringCompare(const PointeredListItem * Item1,
	const PointeredListItem * Item2)
{
	return strcmp((const char *) Item1->GetData(), (const char *) Item2->GetData());
}

#ifdef _TOOLBOX_TEST
	int PointeredList::InstanceCount = 0;
#endif

#ifdef _TOOLBOX_TEST
	void PointeredList::RunTestSuite(int * performedTests, int * failedTests)
	{
	}
#endif


// --- Class PointeredListItem ---

PointeredListItem::PointeredListItem()
{
	#ifdef _TOOLBOX_TEST
		InstanceCount++;
	#endif

	Data = NULL;
}

PointeredListItem::~PointeredListItem()
{
	ASSERTION_THIS;

	#ifdef _TOOLBOX_TEST
		InstanceCount--;
	#endif
}

#ifdef _TOOLBOX_TEST
	int PointeredListItem::InstanceCount = 0;
#endif

#ifdef _TOOLBOX_TEST
	void PointeredListItem::RunTestSuite(int * performedTests, int * failedTests)
	{
	}
#endif
