/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


// Main header file
#include <ToolBox\Headers.h>


// --- Class MP3FileInfos ---

MP3FileInfos::MP3FileInfos()
{
	Artist = NULL;
	Song = NULL;

	SetArtist("");
	SetSong("");
}

MP3FileInfos::~MP3FileInfos()
{
	ASSERTION_THIS;

	if (Artist!=NULL) {delete Artist; Artist = NULL;}
	if (Song!=NULL) {delete Song; Song = NULL;}
}

void MP3FileInfos::Capitalize(char * string)
{
	bool inWord = false;
	for (unsigned int i=0; i<strlen(string); i++)
	{
		string[i] = String::ToLowerCase(string[i]);
		if (string[i]!=' ' && !inWord)
		{
			string[i] = String::ToUpperCase(string[i]);
			inWord = true;
		}
		else
			if (string[i]==' ' && inWord)
				inWord = false;
	}
}

void MP3FileInfos::Normalize()
{
	ASSERTION_THIS;

	Trim(Artist);
	Capitalize(Artist);
	Trim(Song);
	Capitalize(Song);
}

void MP3FileInfos::ReadFrom(const char * path)
{
	ASSERTION_THIS;

	FILE * in = fopen(path, "rb");
	if (in == NULL)
		return;

	fseek(in, 0L, SEEK_END);
	long len = ftell(in);
	for (long pos = len-256; pos < len-3; pos++)
	{
		fseek(in, pos, SEEK_SET);
		if (fgetc(in)=='T' && fgetc(in)=='A' && fgetc(in)=='G')
			break;
	}

	if (pos >= len-3)
	{
		fclose(in);
		return;
	}
	else
	{
		char block[256];
		fseek(in, pos+3, SEEK_SET);
		fread(block, 256, 1, in);
		block[255]=0;
		fclose(in);

		char song[31];
		strncpy(song, block, 30);
		song[30]=0;
		SetSong(song);

		char artist[31];
		strncpy(artist, &block[30], 30);
		artist[30]=0;
		SetArtist(artist);
	}
}

void MP3FileInfos::SetArtist(char * artist)
{
	ASSERTION_THIS;

	if (Artist!=NULL) {delete Artist; Artist = NULL;}
	if ((Artist = new char[strlen(artist)+1]) == NULL)
		throw EOutOfMemory::Get();

	strcpy(Artist, artist);
}

void MP3FileInfos::SetSong(char * song)
{
	ASSERTION_THIS;

	if (Song!=NULL) {delete Song; Song = NULL;}
	if ((Song = new char[strlen(song)+1]) == NULL)
		throw EOutOfMemory::Get();

	strcpy(Song, song);
}

void MP3FileInfos::Trim(char * string)
{
	while (string[0] && string[strlen(string)-1] == ' ')
		string[strlen(string)-1] = 0;
	while (string[0] == ' ')
		memmove(string, &string[1], strlen(&string[1])+1);
}
