/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


// Main header file
#include <ToolBox\Headers.h>


// --- Class AutoDeleting ---

AutoDeleting::~AutoDeleting()
{
	ASSERTION_THIS;

	while (!References.IsEmpty())
		References.GetFirst()->RemoveElement(this);
}

void AutoDeleting::AddReference(class Reference * Reference)
{
	ASSERTION_THIS;
	ASSERTION(Reference != NULL);

	References.Append(Reference);
}

void AutoDeleting::RemoveReference(class Reference * Reference)
{
	ASSERTION_THIS;
	ASSERTION(Reference != NULL);

	References.Unlink(Reference);
	if (References.IsEmpty())
		delete this;
}


// --- Class Reference ---

Reference::Reference(void * referrer)
{
	ASSERTION_THIS;
	Referrer = referrer;
}

Reference::~Reference()
{
	ASSERTION_THIS;
}
